import React, { Component } from 'react';

import { SnackbarHOC, getImageUrl, City } from 'educoder';
import { Form, Button, Input, Radio, Select, Tooltip, Icon  } from 'antd'
const RadioGroup = Radio.Group;
const Option = Select.Option
const radioOptions = [
  { label: '男', value: 'Apple' },
  { label: '女', value: 'Pear' },
];
class AccountBasicEdit extends Component {
  handleSubmit = () => {
    this.props.form.validateFieldsAndScroll((err, values) => {
      if (!err) {

      }
    })
  }
  render() {
    const { getFieldDecorator } = this.props.form;
    const showRealName = false;
    return (
      <div className="basicFormWrap">
        <div className="basicForm">
          <style>{`
            .formItemInline {    
              display: flex;
            }
            .formItemInline .ant-form-item-control-wrapper {
              display: inline-block;
            }

            .basicForm {
              background: #fff;
              padding: 30px;
              width: 930px;
              margin: 20px;
              margin-bottom: 10px;
            }
              .basicForm .title {
                font-size: 16px;
                padding-left: 30px;
                margin-bottom: 10px;
              }
            .basicForm .ant-form-item-label {
              width: 100px;
              padding-right: 10px;
            }
              .basicForm .ant-form-item-label label {
                color: #979797
              }
            .basicForm .display {
              margin: 0
            }
            .titleWrap {
              display: flex;
              justify-content: space-between;
            }
          `}</style>
          <div className="titleWrap">
            <div className="title">基本信息</div>
            <Button type="primary" style={{  marginRight: '16px'}}
              ghost onClick={() => this.props.history.push('/account/basic/edit')}>修改</Button>
          </div>

          <Form onSubmit={this.handleSubmit}>
            <Form.Item
              label="昵称"
              className="display formItemInline"
            >
              hushasha
            </Form.Item>

            <Form.Item
              label="姓名"
              className="display formItemInline"
            >
              胡*莎
            </Form.Item>

            <Form.Item
              label="性别"
              className="display formItemInline"
            >
              女
            </Form.Item>


            <Form.Item
              label="所在地"
              className="display formItemInline"
            >
              湖南省    长沙市
            </Form.Item>

            <Form.Item
              label="职业"
              className="display formItemInline"
            >
              专业人士
            </Form.Item>

            <Form.Item
              label="学校/单位"
              className="display formItemInline mb0"
            >
              中国移动长沙分公司
            </Form.Item>

            <Form.Item
              label="院系/部门"
              className="display formItemInline mb0"
            >
              市场部
            </Form.Item>
          </Form>
          </div>
          <diV style={{color: '#989898', marginLeft: '20px'}}>* 我们确保你所提供的信息均处于严格保密状态，不会泄露</diV>
      </div>
    );
  }
}
const WrappedAccountBasicEdit = Form.create({ name: 'AccountBasicEdit' })(AccountBasicEdit);

export default WrappedAccountBasicEdit;
