class DepartmentsController < ApplicationController
  def for_option
    render_ok(departments: Department.cached_names_data(current_school))
  end

  private

  def current_school
    @_current_school ||= School.find(params[:id])
  end
end