
json.current_user do
  json.id current_user.id
  json.name current_user.real_name
  json.admin current_user.admin?
  json.manager current_school.manager?(current_user)
  json.major_manager current_school.major_manager?(current_user)
  json.course_manager current_school.course_manager?(current_user)
end

json.school do
  json.id current_school.id
  json.name current_school.name
end

json.school_managers @school_managers, partial: 'ecs/shared/user', as: :user
