import React,{ Component } from "react";
import { Modal,Checkbox,Upload,Button,Icon,message,Input,Radio} from "antd";
import axios from 'axios';
import Modals from '../../modals/Modals';
const RadioGroup = Radio.Group;
const Search = Input.Search;

class Associationmodel extends Component{
  constructor(props){
    super(props);
    this.state={
      group_ids:[],
      fileList:[],
      Modalstype:false,
      Modalstopval:"",
      ModalCancel:"",
      ModalSave:"",
      loadtype:false,
      search:undefined,
      page:1,
      limit:"",
      projects:undefined,
      projectvalue:undefined,
      projectvaluetype:false,
    }
  }


  componentDidMount() {
   this.searchValue();
  }

  searchValue=()=>{
    let {search}=this.state;
    let url="/users/search_user_projects.json";
    axios.get(url, {
      params: {
        search: search
      }
    }).then((result)=>{
        console.log(result)
    if(result.status===200){
      this.setState({
        projects:result.data.projects
      })
    }

    }).catch((error)=>{
      console.log(error)
    })
  }

  inputSearchValue=(e)=>{
    this.setState({
      search:e.target.value
    })
  }


  goback=()=>{
   this.props.funlist()
    this.props.Cancel()
    console.log(this.props)
    this.setState({
      Modalstype:false,

    })
  }


   setSaves=()=>{
     let {projectvalue}=this.state;
     let taskid=this.props.taskid;
     let url="/graduation_tasks/"+taskid+"/graduation_works/relate_project.json";

     axios.post(url, {
         project_id: projectvalue
     }).then((result)=>{

       if(result.status===200){
         if(result.data.status===0){

           this.setState({
             Modalstype:true,
             Modalstopval:result.data.message,
             ModalSave:this.goback,
             loadtype:true
           })

         }

       }

     }).catch((error)=>{
       console.log(error)
     })
   }
  Saves=()=>{
    let {projectvalue}=this.state;
    if(projectvalue===undefined||projectvalue===""){
      this.setState({
        projectvaluetype:true,
      })
    }else{
      this.setState({
        projectvaluetype:false,
      })
    }
    let taskid=this.props.taskid;
    console.log(this.props)
     let url="/graduation_tasks/"+taskid+"/graduation_works/check_project.json";
     axios.get(url, {
       params: {
         project_id: projectvalue
       }
     }).then((result)=>{

       if(result.status===200){

         if(result.data.is_relate===false){

              this.setSaves()

         }else{

           this.setState({
             Modalstype:true,
             Modalstopval:"该项目已被"+result.data.relate_user+"关联",
             ModalSave:this.ModalSave,
             loadtype:true
           })

         }

       }

     }).catch((error)=>{
       console.log(error)
     })
  }

  onChange = (e) => {

    this.setState({
      projectvalue: e.target.value,
    });

  }

  ModalSave=()=>{
    this.setState({
      Modalstype:false
    })
  }

  render(){
    let {
      Modalstype,
      Modalstopval,
      ModalCancel,
      ModalSave,
      loadtype,
      search,
      projects,
      projectvalue,
      projectvaluetype
    }=this.state;



    return(
      <div>
        {/*提示*/}
        <Modals
          modalsType={Modalstype}
          modalsTopval={Modalstopval}
          modalCancel={ModalCancel}
          modalSave={ModalSave}
          loadtype= {loadtype}

        />
        <Modal
          className={"HomeworkModal"}
          title={this.props.modalname}
          // visible={this.props.visible}
          visible={this.props.visible}
          closable={false}
          footer={null}
          keyboard={false}
          destroyOnClose={true}
        >
          <div className="task-popup-content">
            <p className="task-popup-text-center font-16">

              <Search
                placeholder="请输入项目名称进行搜索"
                id="subject_search_input"
                value={search}
                onInput={this.inputSearchValue}
                onSearch={this.searchValue}
                autoComplete="off"
              ></Search>

            </p>

            <div className={"Association mb20"}>

              <RadioGroup onChange={this.onChange} value={projectvalue}>

                {projects&&projects.map((item,key)=>{
                  return(
                    <div key={key} style={{
                      width: '375px',
                      height: '30px'
                    }}>
                      <Radio value={item.project_id} className="fl "></Radio>
                      <div className={"fl ml5"}>{item.project_name}</div>
                    </div>
                  )
                })}

              </RadioGroup>

            </div>

            {projectvaluetype===true?<span className={"color-red ml20 "}>请先选择项目</span>:""}

            <div className="clearfix mt30 edu-txt-center mb10">
              <a  className="task-btn color-white mr80" onClick={this.props.Cancel}>取消</a>
              <a className="task-btn task-btn-orange" onClick={this.Saves}>确认</a>
            </div>

          </div>
        </Modal>
      </div>
    )
  }
}
export default Associationmodel;